-rw-r--r-- | delta.jscad | 29 |
1 files changed, 29 insertions, 0 deletions
diff --git a/delta.jscad b/delta.jscad index 326d172..35a777c 100644 --- a/delta.jscad +++ b/delta.jscad @@ -1,341 +1,370 @@ var PRINT = { layer_height: 0.2, extrusion_width: 0.4, fit_tolerance: .2, slide_tolerance: .4, play_tolerance: .6, screw_tolerance: .3 }; var CONFIG = { extrusion: { w: 20, slotdepth: 6 }, base: { el: 240, // side extrusion length sl: 240+2*70, // triangle side length gap: 9 // vertical gap between side extrusions }, column: { h: 600 // column height }, heatbed: { r: 220/2, // heatbed radius sr: 220/2-4.5, // radius of the screwholes circle h: 3+1.5 // thickness (including insulation) }, glass: { r: 195/2, // glass radius h: 3 // glass thickness }, duet: { pcb_size: { x: 124, y: 100, z: 1 }, hole_spacing: { x: 115, y: 92 }, h: 30 }, foot: { d: 20*Math.sqrt(2), h: 30, bolt: { d:5, l: 19, hd: 10 }, margin: 2.5, nut: { d: 8.6 /* TODO: */, h: 3.5 }, shell: 4, zscalefactor: 1.6, foot: { ho: 2.5, hi: 5 } }, duetholder: { bolt: { d: 3, l: 10, head: { d: 5.33, h: 3 } }, margin: 3, s: 2.5 }, bedholder: { h: 15, margin: 3, nut: { w: 5.4, h: 2.5 }, bolt: { d: 3, l: 10, head: { d: 5.33, h: 3 } } }, hotend: { h: 62.4, // full assembly height groove: { d:12, h:6 }, // grove diameter and height ungroove: { d:16, above:3.7, below: 3+4 } }, effector: { h: 6, o: 20, // offset to the rod mounts line rods_apart: 40, cone: { shell: 1, angle: Math.PI/6 }, rodend: { joint_w: 7, // thickness of the joint screw_l: 20-1, // 20 with the head screw_d: 3 }, hotend: { margin: 2 }, hinge: { d: 3, w: 5, margin: 2.5, h: 1+(6+3.7)/2, // elevation + grove + top e: 1 // elevation }, clamp: { shell: 4.6, d: 3, margin: 2.5, split: 0.6 }, mswitch: { size: [ 19.8, 6, 10 ], screw: { d: 2, h: 10/2-2, s: 1.3, // screw shell o: [-9.5/2,9.5/2].map(function(x) { return -19.8/2+x; }) }, switch_x: 2.5 }, guide: { width: 3, height: 5+1, length: 6 }, fanholder: { r: 30, screw: { d: 3, m: 2.5/*margin*/ }, w: 3 } }, nut: { h: 2.3, w: 5.5 }, color: { extrusion: [0.8, 0.8, 0.8, 0.8], pcb: [ 0, 0.3, 0.2, 0.8 ], bulk: [ .9, .9, .9, .2 ], parts: [ 0, 0.8, 0, 0.9 ], softparts: [ 0, 0, 0.8, 0.9 ], heatbed: [0.8, 0.8, 0.8, 0.8 ], glass: [0.9, 0.9, 0.9, 0.7 ] } }; var CD = { base: (function(){ var rv = {}; rv.circumscription_r = CONFIG.base.sl/2/Math.cos(Math.PI/6); rv.outer_inscription_r = Math.sqrt(Math.pow(rv.circumscription_r,2)- Math.pow(CONFIG.base.sl/2,2)); rv.mid_inscription_r = rv.outer_inscription_r-CONFIG.extrusion.w/2; rv.inner_inscription_r = rv.outer_inscription_r-CONFIG.extrusion.w; // TODO: properly calculate rv.column_r = rv.circumscription_r - 48.29; return rv; })(), duetholder: (function() { var rv = {}; var s = CONFIG.base.sl; var l = CONFIG.duet.hole_spacing.x; var w = CONFIG.duet.hole_spacing.y; var h = s*Math.cos(Math.PI/6); var h1 = h*(1-l/s); rv.distance = (h1-w)/3; // hole to side return rv; })() }; console.log(CONFIG); console.log(CD); var U = { hypotenuse: function(a,b) { return Math.sqrt(Math.pow(a,2)+Math.pow(b,2)); }, peek: function(x,m) { console.log(x,m); return x; + }, + axes: function U_axes(o) { + if(!o) o = {}; + var l = o.l||20, g = o.g||0.7; + return union([ + CSG.roundedCylinder({start:[0,0,0],end:[l,0,0]}).setColor([1,0,0,g]), + CSG.roundedCylinder({start:[0,0,0],end:[0,l,0]}).setColor([0,1,0,g]), + CSG.roundedCylinder({start:[0,0,0],end:[0,0,l]}).setColor([0,0,1,g]) + ]); + }, + pextract: function U_pextract(a,pn) { // TODO: monkeypatch Array + return a.map(function(x){return x[pn]}); + }, + hole: function U_hole(o) { + var r = o.r||o.radius||(o.d/2)||(o.diameter/2); + var n = Math.max(Math.round(4*r),4); + return CSG.cylinder({ + start: o.start, end: o.end, + radius: r/Math.cos(Math.PI/n), + resultion: n + }); + }, + + upright: function U_upright() { return new CSG.Connector([0,0,0],[0,0,1],[1,0,0]) }, + downright: function U_downright() { return new CSG.Connector([0,0,0],[0,0,-1],[1,0,0]) }, + P: function U_P(x) { + if(!x.properties.P) return x; + return x.connectTo(x.properties.P,U.upright(),false,0); } + }; /* {h:,w:} */ function nut(o) { var rv = CSG.cylinder({ start:[0,0,0],end:[0,0,o.h], radius: o.w/2/Math.cos(Math.PI/6), resolution: 6 }); rv.properties.axis_connector = new CSG.Connector([0,0,0],[0,0,1],[0,1,0]); return rv; } var E3DV6 = { dimensions: { big_d: 22.3, }, heatsink: function() { var fn = 16; var z=0; var unite = [ {d:16,h:3.7},{d:12,h:6},{d:16,h:3} ].map(function(x) { return CSG.cylinder({ start: [0,0,z], end: [0,0,z-=x.h], radius: x.d/2, resolution: fn }); }); unite.push(CSG.cylinder({ start:[0,0,z-=1.5], end:[0,0,z-=1], radius: 16/2, resolution: fn })); for(var i=0;i<11;++i) unite.push(CSG.cylinder({ start:[0,0,z-=1.5], end:[0,0,z-=1], radius: this.dimensions.big_d/2, resolution: fn })); unite.push(CSG.cylinder({ start:[0,0,z], end: [0,0,-12.7], radiusStart: 10/2, radiusEnd: 8.5/2, /* pretty arbitrary */ resolution: fn })); var rv = union(unite); rv = rv.subtract([CSG.cylinder({ start:[0,0,1], end: [0,0,z-1], radius: 4.2/2, resolution: fn }),CSG.cylinder({ start:[0,0,1], end: [0,0,-6.7/*somewhat arbitrary*/], radius: 8/2, resolution: fn }),CSG.cylinder({ start:[0,0,z-1], end: [0,0,z+14.8], radius: 6/2 /*M7*/, resolution: fn })]); rv.properties.pushfit_connector = new CSG.Connector([0,0,0],[0,0,-1],[1,0,0]); rv.properties.heatbreak_connector = new CSG.Connector([0,0,z+14.8],[0,0,-1],[1,0,0]); rv.properties.grove_connector = new CSG.Connector([0,0,-3.7-3],[0,0,1],[1,0,0]); return rv.setColor([0.8,0.8,0.8,0.9]); } }; var EFFECTOR = { /* {sd: screw diameter, l: cone length, s: screw shell, a: angle from axis} */ cone: function effector_cone(o) { var re = o.sd/2+o.s, rs = re+o.l*Math.tan(o.a||(Math.PI/4)); var rv = CSG.cylinder({ start: [0,0,0], end: [0,0,o.l], radiusStart: rs, radiusEnd: re, resolution: Math.floor(rs*2*2) }).subtract(CSG.cylinder({ start:[0,0,-1], end:[0,0,o.l+1], radius: o.sd, //resolution: Math.floor(o.sd*2*2) })); rv.properties.top_connector = new CSG.Connector([0,0,o.l],[0,0,-1],[1,0,0]); rv.properties.bottom_connector = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); var nuthole = nut(CONFIG.nut); rv = rv.subtract(nuthole.connectTo( nuthole.properties.axis_connector, rv.properties.bottom_connector, false, 0 )); return rv.intersect(CSG.cylinder({start:[0,0,0],end:[0,0,o.l],radius:6/*TODO:calculate*/})); }, platform_bb: function platform_bb() { var e = CONFIG.effector; var r = U.hypotenuse(e.rods_apart/2,e.o+e.rodend.screw_d/2+e.cone.shell); var rv = CSG.sphere({ center: [0,0,e.h/2], radius: r, resolution: r*2*2 }).intersect(CSG.cube({ corner1: [-r,-r,0], corner2: [r,r,e.h] })); rv.properties.base_connector = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); return rv; }, effector: function effector_effector() { var e = CONFIG.effector; var conel = e.rodend.screw_l-e.rodend.joint_w; var nutr = CONFIG.nut.w/2/Math.cos(Math.PI/6); var cone = this.cone({sd:e.rodend.screw_d/2,l:conel,s:e.cone.shell,a:e.cone.angle}); var rcorner = U.hypotenuse(e.o-e.rodend.screw_d/2-e.cone.shell,e.rods_apart/2)-3.85; //XXX:config/calc var ropen = E3DV6.dimensions.big_d/2+e.hotend.margin; var rmount = this.rmount = (rcorner+ropen)/2; var rv = []; for(var a=0;a<360;a+=120) { rv.push(union([-1,1].map(function(s) { return cone.connectTo(cone.properties.top_connector, new CSG.Connector([s*e.rods_apart/2,e.o,e.h/2],[-s,0,0],[0,0,1]), false, 0); })).union(CSG.cube({ corner1:[e.rods_apart/2-conel+.1,e.o-nutr,0], corner2:[-e.rods_apart/2+conel-.1, -rcorner, e.h] })).rotateZ(a)); } rv.push(CSG.cylinder({ start:[0,0,0], end:[0,0,e.h], radius: U.hypotenuse(e.o-nutr,e.rods_apart/2-conel) })); rv = union(rv).intersect(this.platform_bb()).subtract(CSG.cylinder({ start:[0,0,-1], end:[0,0,e.h+1], radius: ropen, resolution: ropen*4 })).subtract([/*0, probe here*/120,240].map(function(x) { /* nut pockets */ return CSG.cube({ corner1:[-CONFIG.nut.w/2,0,(e.h-CONFIG.nut.h)/2], corner2:[CONFIG.nut.w/2,-rcorner-1,(e.h+CONFIG.nut.h)/2] }).union(CSG.cylinder({ start:[0,-rmount,-1], end:[0,-rmount,e.h+1], radius: 3/2 // XXX: })).subtract(CSG.cylinder({ start:[0,-rmount,(e.h+CONFIG.nut.h)/2], end:[0,-rmount,(e.h+CONFIG.nut.h)/2+PRINT.layer_height*3/2], radius: 3/2+.1 })).rotateZ(x); })).subtract( CSG.cylinder({ // pulldown screw start: [0,-rcorner+e.mswitch.size[1]+PRINT.extrusion_width+3/2/*XXX:conf*/,-1], end: [0,-rcorner+e.mswitch.size[1]+PRINT.extrusion_width+3/2/*XXX:conf*/,e.h+1], radius: 3/2+1 /*XXX: config */ })).subtract( CSG.cylinder({ /* switch-screw */ start: [e.mswitch.switch_x,-rcorner+e.mswitch.size[1]/2,-1], end: [e.mswitch.switch_x,-rcorner+e.mswitch.size[1]/2,e.h+1], radius: e.mswitch.screw.d/2 })); // add hinges rv.properties.hinge_connector=new CSG.Properties(); var hinges_apart=e.rods_apart/2-conel; rv = rv.union([-1,1].map(function hinge(s) { rv.properties.hinge_connector[s]=new CSG.Connector([s*hinges_apart,e.o,e.h+e.hinge.h],[s,0,0],[0,0,1]); return CSG.cube({ corner1: [s*hinges_apart,e.o-e.hinge.margin-e.hinge.d/2,e.h], corner2: [s*(hinges_apart+e.hinge.w),e.o+e.hinge.margin+e.hinge.d/2,e.h+e.hinge.h] }).union(CSG.cylinder({ start: [s*hinges_apart,e.o,e.h+e.hinge.h], end: [s*(hinges_apart+e.hinge.w),e.o,e.h+e.hinge.h], radius: e.hinge.d/2+e.hinge.margin })).subtract(CSG.cylinder({ start: [s*(hinges_apart-1),e.o,e.h+e.hinge.h], end: [s*(hinges_apart+e.hinge.w+1),e.o,e.h+e.hinge.h], radius: e.hinge.d/2 })); })); // add clamp guides var cgrr = e.guide.width/3; rv = rv.union([-1,1].map(function guide(s) { return CSG.roundedCube({ center: [s*(e.mswitch.size[0]+PRINT.slide_tolerance+e.guide.width)/2,-rcorner+e.guide.length/2,e.h+e.guide.height/2-cgrr], radius: [e.guide.width/2,e.guide.length/2,e.guide.height/2+cgrr], roundradius: cgrr }).intersect(CSG.cube({ center: [s*(e.mswitch.size[0]+PRINT.slide_tolerance+e.guide.width)/2,-rcorner+e.guide.length/2,e.h+e.guide.height/2], radius: [e.guide.width/2,e.guide.length/2,e.guide.height/2+.1], roundradius: cgrr })); })); rv.properties.grove_connector = new CSG.Connector([0,0,e.h+e.hinge.e+6/2],[0,0,1],[1,0,0]); rv.properties.rcorner = rcorner; return rv.setColor([0.4,0.8,0.4,0.9]); }, hinged: function effector_hinged(o) { var e = CONFIG.effector; var conel = e.rodend.screw_l-e.rodend.joint_w; var hinges_apart = e.rods_apart/2-conel; var hhr = e.o-e.hinge.d/2-e.hinge.margin; // hotend holder radius var hhh = CONFIG.hotend.groove.h+CONFIG.hotend.ungroove.above; var rv = CSG.cylinder({ /* hinge */ start: [-hinges_apart+PRINT.slide_tolerance,e.o,e.h+e.hinge.h], end: [hinges_apart-PRINT.slide_tolerance,e.o,e.h+e.hinge.h], radius: e.hinge.d/2+e.hinge.margin }).union( /* lower hotend holder */ CSG.cylinder({ start: [0,0,e.h+e.hinge.e], end: [0,0,e.h+e.hinge.e+CONFIG.hotend.groove.h], radius: hhr }).subtract(CSG.cylinder({ start: [0,0,e.h+e.hinge.e-1], end: [0,0,e.h+e.hinge.e+CONFIG.hotend.groove.h+1], radius: CONFIG.hotend.groove.d/2 +PRINT.fit_tolerance |